# -*- coding: utf-8 -*-

import sys, os, time
import json
import pymysql as mysql
import logging, logging.config
from artix.database.info import DBInfo

logging.config.fileConfig('maint_log.ini')

logger = logging.getLogger('su.artix.shiftdeleting')

if __name__ == '__main__':

    queries = [
          "DELETE b FROM document doc LEFT JOIN workshift w ON w.workshiftid = doc.workshiftid LEFT JOIN goodsitem g ON doc.documentid = g.documentid LEFT JOIN discitem di ON g.goodsitemid = di.goodsitemid LEFT JOIN button b ON di.buttonid = b.buttonid WHERE w.shiftnum = %(shift)s ",
          "DELETE c FROM document doc LEFT JOIN workshift w ON w.workshiftid = doc.workshiftid LEFT JOIN client c ON doc.clientitemid = c.clientitemid WHERE w.shiftnum = %(shift)s ",
          "DELETE c FROM document doc LEFT JOIN workshift w ON w.workshiftid = doc.workshiftid LEFT JOIN carditem ci ON doc.documentid = ci.documentid LEFT JOIN client c ON ci.clientitemid = c.clientitemid WHERE w.shiftnum = %(shift)s ",
          "DELETE g, b, d, c, p FROM document doc LEFT JOIN workshift w ON w.workshiftid = doc.workshiftid LEFT JOIN goodsitem g ON doc.documentid = g.documentid LEFT JOIN button b ON g.buttonid = b.buttonid LEFT JOIN department d ON g.departmentid = d.departmentid LEFT JOIN `client` c ON d.clientitemid = c.clientitemid LEFT JOIN paymentitem p ON g.paymentitemid = p.paymentitemid WHERE w.shiftnum = %(shift)s ",
          "DELETE g, b, d, c, p FROM document doc LEFT JOIN workshift w ON w.workshiftid = doc.workshiftid LEFT JOIN stornogoodsitem g ON doc.documentid = g.documentid LEFT JOIN button b ON g.buttonid = b.buttonid LEFT JOIN department d ON g.departmentid = d.departmentid LEFT JOIN `client` c ON d.clientitemid = c.clientitemid LEFT JOIN paymentitem p ON g.paymentitemid = p.paymentitemid WHERE w.shiftnum = %(shift)s ",
          "DELETE b, dp, c FROM document d LEFT JOIN workshift w ON w.workshiftid = d.workshiftid LEFT JOIN button b ON d.buttonid = b.buttonid LEFT JOIN department dp ON d.departmentid = dp.departmentid LEFT JOIN `client` c ON dp.clientitemid = c.clientitemid WHERE w.shiftnum = %(shift)s ",
          "DELETE c FROM crights c join (select workshiftid FROM workshift WHERE workshift.shiftnum = %(shift)s ) w ON c.workshiftid = w.workshiftid",
          "DELETE FROM workshift WHERE workshift.shiftnum = %(shift)s "
      ]
    logger.info("Сервис maint_db начал работу")
    data_file = open('/linuxcash/cash/conf/maint.json')
    data = json.load(data_file)
    shiftCount = data["manual"]["shiftCount"] if "manual" in data.keys() else 180
    timeout = data["manual"]["timeout"] if "manual" in data.keys() else 240
    dbInfo = DBInfo
    conn = mysql.connect(host=dbInfo.host, port=dbInfo.port, user=dbInfo.user, password=dbInfo.password, database="documents")
    cur = conn.cursor()
    cur.execute('set names utf8')
    query = "SELECT shiftnum FROM workshift ORDER BY time_beg IS NOT NULL, time_beg DESC LIMIT %s,1000000 " % shiftCount
    cur.execute(query)
    shiftList = cur.fetchall()
    if not shiftList:
        logger.info("Смены для удаления не найдены")
    else:
        logger.info("Найдено смен для удаления: %s" % len(shiftList))
    
    for shift in shiftList:
        shift = shift[0]
        logger.info('Удаление смены #%s ' % shift)
        for queryStr in queries:
            query = queryStr % vars()
            cur.execute(query)
            conn.commit()
        logger.info('Cмена #%s удалена' % shift)
        time.sleep(timeout)
    cur.close()
    conn.close()
    logger.info("Сервис maint_db закончил работу")
